Index: trunk/expressoMail1_2/js/main.js
===================================================================
--- trunk/expressoMail1_2/js/main.js	(revision 5083)
+++ trunk/expressoMail1_2/js/main.js	(revision 5134)
@@ -1685,105 +1931,70 @@
 	{
 		var newImage = false;
+		RichTextEditor.saveFlag = 1;
 		openTab.imapUid[border_id] = data.msg_no;
 		openTab.imapBox[border_id] = data.folder_id;
 
 		var newTitle = document.getElementById('subject_'+border_id).value;
-		if (newTitle == '')
+		if (newTitle.length > 18)
+                    newTitle = newTitle.substr(18) + '...';
+                else if (newTitle == '')
                     newTitle = get_lang("No subject");
-		set_border_caption('border_id_'+border_id, newTitle);
+		document.getElementById('font_border_id_'+border_id).innerHTML = newTitle;                 
+                Element('border_id_'+border_id).title = newTitle; 
 
 		// Replace the embedded images for new uids
 		var content_body  = RichTextEditor.getData('body_'+border_id);
-
-                if (is_ie)
+		var body_images   = content_body.match(/msgNumber=\d*/g);
+		var folder_images = content_body.match(/msgFolder=[^&]*&/g); 		
+
+                if (body_images != null)
                 {
-                    var content_body =  mainField.document.getElementsByTagName('body').item(0).innerHTML;
-                    var body_images = content_body.match(/msg_num=\d*/g);
-                    var images_part = content_body.match(/msg_part=\d*/g);
-                    if (body_images)
+                    for (var i=0; i<body_images.length; i++)
                     {
-                        for (var i=0; i<body_images.length; i++){
-                            content_body = content_body.replace(body_images[i],"msg_num="+openTab.imapUid[border_id]);
+                        if( folder_images != null)
+                          content_body = content_body.replace(folder_images[i], "msgFolder=INBOX" + cyrus_delimiter + draftsfolder +"&");
+
+
+                            
+                        
+                        content_body = content_body.replace(body_images[i],"msgNumber="+openTab.imapUid[border_id]);
+                    }
+
+                    var images_part   = content_body.match(/indexPart=[0-9.]*/g);
+
+                    if(images_part != null)
+                                {
+                        for (var x = 0; x < images_part.length; x++)
+                                {
+                            var position = images_part[x].substr(10,images_part[x].length);
+                            content_body = content_body.replace(images_part[x],'indexPart(||.|||.||)='+data.imagesParts[position]);
+                                }
+
                         }
-
-                        var allImgs = new Array (images_part.length);
-                        //var j=-1;
-                        for (var i in images_part){
-
-                            if (i == 0)
-                                var image_number = parseInt(images_part[i].substr(9));
-                            else
-                                image_number = "null";
-                            
-                            if (! isNaN(image_number))
-                            {
-                                if (! allImgs[image_number])
-                                {
-                                    allImgs[image_number] = true;
-                                    //j--;
-                                }
-                                //content_body = content_body.replace(images_part[i],'msg_part='+j);
-                            }
-                            //content_body = content_body.replace(/msg_part=-/g,'msg_part=');
-                        }
-                        
+               	    content_body = content_body.replace(/indexPart\(\|\|\.\|\|\|\.\|\|\)=/g,'indexPart=');             
                     }
-                }
-                else
-                    {
-                        for (var i = 0; i < bodyChildNodes.length; i++){
-                            if (typeof(bodyChildNodes[i].tagName) != 'undefined' && bodyChildNodes[i].tagName.search(/img/i) != -1)
-                            {
-                                bodyChildNodes[i].src =  bodyChildNodes[i].src.replace(/msg_num=\d*/g, "msg_num="+openTab.imapUid[border_id]);
-
-                                var allImgs = new Array();
-                                var image_number = parseInt(bodyChildNodes[i].src.match(/msg_part=\d*/g)[0].substr(9));
-                                if (! allImgs[image_number])
-                                {
-                                    allImgs[image_number] = true;
-                                }
-                            }
-                            else
-                                {
-                                    continue;
-                                }
-
-                        }
-                    }
+
+                   
 
 		//Replace all files to new files
 		var divFiles = Element("divFiles_"+border_id);
-		elFiles = divFiles.getElementsByTagName("input");
-		var countCheck =0;
-		for (var i=0; i<elFiles.length; i++) {
-                    if(elFiles[i].value !=""){
-                        if (elFiles[i].type == "checkbox") {
-                            var tmpData = connector.unserialize(decodeURIComponent(elFiles[i].value));
-                            tmpData[1] = data.msg_no;
-                            elFiles[i].value = encodeURIComponent(connector.serialize(tmpData));
-                            countCheck++;
-                        }
-                        else {
-                            elFiles[i].value ="";
-                            parantNodeFile = elFiles[i].parentNode.parentNode;
-                            parantNodeFile.removeChild(elFiles[i].parentNode);
-                            i--;
-                        }
-                    }
-		}
+		divFiles.innerHTML = '';
+
 
 		var attach_files = connector.unserialize(data.files);
 		if (attach_files != null) {
                     openTab.countFile[border_id] = attach_files.length;
-                    att_index = countCheck;
-                    for (att_index; att_index < attach_files.length; att_index++)
-                    {
+                    for (var att_index = 0; att_index < attach_files.length; att_index++){
 
                         var link_attachment = document.createElement("a");
-			var fileName = attach_files[att_index].substr(0,attach_files[att_index].indexOf('_SIZE_'));
-			var fileSize = parseInt(attach_files[att_index].substr(attach_files[att_index].indexOf('_SIZE_')+6))/1024
-			link_attachment.innerHTML = fileName + " ("+borkb((parseInt(fileSize)*1024))+")";
-
-                        var href = "'"+folder_id+"','"+data.msg_no+"','"+(att_index)+"','"+(att_index+2)+"','base64'";
+
+                        var fileName = Base64.decode(attach_files[att_index].name);
+                        var fileSize = attach_files[att_index].size / 1024;
+                        
+                        
+                        link_attachment.innerHTML = fileName + " ("+parseInt(fileSize)+" kb)";
+						
+						var encoding = /\.eml$/.exec(fileName)? '7bit' : 'base64';
+                        var href = "'"+folder_id+"','"+data.msg_no+"','"+(att_index)+"','0."+(att_index+1)+"','"+encoding+"'";
 
                         link_attachment.setAttribute("href", "javascript:download_attachments("+href+")");
@@ -1793,27 +2004,18 @@
                         s_tmp = escape(connector.serialize(a_tmp));
 
-                        var check_attachment = document.createElement("INPUT");
+                        var check_attachment = document.createElement("input");
 			check_attachment.type = 'CHECKBOX';
 			check_attachment.name = 'forwarding_attachments[]';
-			check_attachment.value = trim(s_tmp);
-
-                        if (!divFiles.childNodes[0])
-                        {
-                            divFiles.appendChild(document.createElement("BR"));
-                        }
-                        else
-                            {
-                                divFiles.insertBefore(document.createElement("BR"),divFiles.childNodes[0]);
-                            }
-
-                        divFiles.insertBefore(link_attachment,divFiles.childNodes[0]);
-                        divFiles.insertBefore(check_attachment,divFiles.childNodes[0]);
-
-                        check_attachment.checked = true;
-                        check_attachment.setAttribute("checked", "checked");
+                        check_attachment.value = s_tmp;
+
+
 
                         divFiles.appendChild(check_attachment);
                         divFiles.appendChild(link_attachment);
+
                         divFiles.appendChild(document.createElement("br"));
+						
+						check_attachment.checked = true;
+                        check_attachment.setAttribute("checked", "checked");
                     }
 					} 
@@ -1843,18 +2045,12 @@
                         change_tr_properties(tr_msg, data.msg_no, data.subject);
                     }
-		} else {
-                    refresh();
-		}
-
-		var save_link = Element("save_message_options_"+border_id);
-		save_link.onclick = '';
-		save_link.className = 'message_options_inactive';
-		watch_changes_in_msg(border_id);
-		write_msg(get_lang('Your message was save as draft in folder %1.', lang_folder(folder_name)));
-                setTimeout( function(){RichTextEditor.saveFlag = 1;}, 1000 );
-	}
-}
-
-function save_msg(border_id,withImage){
+
+	}
+                setTimeout( function(){RichTextEditor.saveFlag = 1;RichTextEditor.execPosInstance('body_'+border_id);}, 1000 );
+	}
+        return null;
+}
+
+function save_msg(border_id,withImage, out){
 	if (typeof(withImage) == 'undefined')
 		withImage = false;
@@ -1867,5 +2063,5 @@
 		var folder_id = openTab.imapBox[border_id];
 	else
-		var folder_id = "INBOX/"+draftsfolder;
+		var folder_id = "INBOX" + cyrus_delimiter + draftsfolder;
 
 	if (folder_id == 'INBOX') // and folder name from border
@@ -1879,13 +2075,62 @@
 	tmp_folder_id=folder_id;
 	message_id = openTab.imapUid[border_id];
-	var handler_save_msg = function(data){return_save(data,this.tmp_border_id,this.tmp_folder_name,this.tmp_folder_id,this.message_id);}
+	var handler_save_msg = function(data){
+		if(typeof(out) == 'undefined'){
+			return_save(data,this.tmp_border_id,this.tmp_folder_name,this.tmp_folder_id,this.message_id);
+			var save_link = Element("save_message_options_"+border_id);
+			if(!withImage){
+				if(data.append === true){
+					save_link.className = 'message_options_inactive';
+					save_link.onclick = '';
+					watch_changes_in_msg(border_id);	
+					write_msg(get_lang('Your message was save as draft in folder %1.', lang_folder(folder_name)));
+				}
+				if(auto){
+					auto = false;
+				}
+			}
+			else{
+				write_msg(get_lang('Wait a moment, your image is uploading ...'));
+				var auto = true;
+				setTimeout( function(){save_msg(border_id)}, 1000 );
+			}
+		}else{
+			if(data.append === true){
+				write_msg(get_lang('Your message was save as draft in folder %1.', lang_folder(folder_name)));
+			}else if(data.append == null){
+				write_msg(get_lang('ERROR saving your message.'));
+			}if(data.append === "Over quota"){
+				write_msg(get_lang('ERROR saving your message over quota.'));
+			}
+		}
+		
+	}
 
         var mail_as_plain = document.getElementById( 'textplain_rt_checkbox_' + border_id );
 	mail_as_plain = ( mail_as_plain ) ? mail_as_plain.checked : false;
 
+        var content_body  = RichTextEditor.getData("body_"+border_id);
+       //Remove imagens do corpo que estao com o checkbox desmarcados
+       var files_checkbox =  $("#divFiles_"+border_id+" input:checkbox");
+       var files_unchecked = new Array();
+       for (var i = 0; i < files_checkbox.length; i++)
+            if(files_checkbox[i].checked !== true)
+                files_unchecked.push(connector.unserialize(unescape(trim(files_checkbox[i].value))));
+
+       var imagens = content_body.match(/<img[^>]*>/g);
+       if(imagens != null)
+            for (var x = 0; x < imagens.length; x++)
+                for (var xx = 0; xx < files_unchecked.length; xx++)
+                    if(imagens[x].indexOf('indexPart='+files_unchecked[xx][3].replace(/'/g,'')) !== -1)
+                         content_body = content_body.replace(imagens[x],'');
+        
+        if(files_unchecked.length > 0)
+            RichTextEditor.setData("body_"+border_id,content_body);
+            
+        
 	var textArea = document.createElement("TEXTAREA");
 	textArea.style.display='none';
 	textArea.name = "body";
-	textArea.value = RichTextEditor.getData("body_"+border_id);
+	textArea.value = content_body;
 	var input_folder = document.createElement("INPUT");
 	input_folder.style.display='none';
@@ -1948,5 +2193,5 @@
 	}
 	else
-		write_msg('ERROR saving your message.');
+		write_msg(get_lang('ERROR saving your message.'));
 }
 
@@ -1957,8 +2202,25 @@
 	tmp_folder_name=folder_name;
 	var handler_save_msg = function(data){return_saveas(data,this.tmp_border_id,this.tmp_folder_name);}
+        
+       var content_body  = RichTextEditor.getData("body_"+border_id);
+       //Remove imagens do corpo que estao com o checkbox desmarcados
+       var files_checkbox =  $("#divFiles_"+border_id+" input:checkbox");
+       var files_unchecked = new Array();
+       for (var i = 0; i < files_checkbox.length; i++)
+            if(files_checkbox[i].checked !== true)
+                files_unchecked.push(connector.unserialize(unescape(trim(files_checkbox[i].value))));
+
+       var imagens = content_body.match(/<img[^>]*>/g);
+       
+       if(imagens != null)
+            for (var x = 0; x < imagens.length; x++)
+                for (var xx = 0; xx < files_unchecked.length; xx++)
+                    if(imagens[x].indexOf('indexPart='+files_unchecked[xx][3].replace(/'/g,'')) !== -1)
+                         content_body = content_body.replace(imagens[x],'');
+        
 	var textArea = document.createElement("TEXTAREA");
 	textArea.style.display='none';
 	textArea.name = "body";
-	textArea.value = RichTextEditor.getData("body_"+border_id);
+	textArea.value = content_body;
 
 	var input_folder = document.createElement("INPUT");
@@ -1984,11 +2246,7 @@
 function set_messages_flag(flag, msgs_to_set){
 	var handler_set_messages_flag = function (data){
-		var _tab_sufix = getTabSufix();
-		var _chk_box;
-		var _fld_box;
 		if(!verify_session(data))
 			return;
-		var msgs_to_set = data.msgs_to_set.split(","); // messages ids
-		var rowids_to_set = data.rowids_to_set.split(","); // rows ids
+		var msgs_to_set = data.msgs_to_set.split(",");
 
 		if(!data.status) {
@@ -1996,6 +2254,6 @@
 			Element('chk_box_select_all_messages').checked = false;
 			for (var i = 0; i < msgs_to_set.length; i++) {
-				Element("check_box_message_" + rowids_to_set[i]).checked = false;
-				remove_className(Element(rowids_to_set[i]), 'selected_msg');
+				Element("check_box_message_" + msgs_to_set[i]).checked = false;
+				remove_className(Element(msgs_to_set[i]), 'selected_msg');
 			}
 			if(!data.msgs_unflageds)
@@ -2027,33 +2285,32 @@
 				}
 				proxy_mensagens.get_msg(msgs_to_set[i],current_folder, false, setFlag);
-			}
-
-			_chk_box = Element("check_box_message_" + rowids_to_set[i]);
-			_fld_box = (_tab_sufix ? Element("check_box_message_" + msgs_to_set[i]) : null);
-			if(_chk_box){
+
+
+			}
+			if(Element("check_box_message_" + msgs_to_set[i])){
 				switch(data.flag){
 					case "unseen":
-						set_msg_as_unread(rowids_to_set[i]);
-						if (_fld_box)
 						    set_msg_as_unread(msgs_to_set[i]);
-						_chk_box.checked = false;
+						if(results_search_messages != "") 
+							set_msg_as_unread(results_search_messages, true);
+						Element("check_box_message_" + msgs_to_set[i]).checked = false;
 						break;
 					case "seen":
-						set_msg_as_read(rowids_to_set[i], false);
-						if (_fld_box)
-							set_msg_as_read(msgs_to_set[i]);
-						_chk_box.checked = false;
+						set_msg_as_read(msgs_to_set[i], false);
+						if(results_search_messages != "") 
+							set_msg_as_read(results_search_messages, false, true);
+						Element("check_box_message_" + msgs_to_set[i]).checked = false;
 						break;
 					case "flagged":
-						set_msg_as_flagged(rowids_to_set[i]);
-						if (_fld_box)
 						    set_msg_as_flagged(msgs_to_set[i]);
-						_chk_box.checked = false;
+						if(results_search_messages != "") 
+							set_msg_as_flagged(results_search_messages, true);
+						document.getElementById("check_box_message_" + msgs_to_set[i]).checked = false;
 						break;
 					case "unflagged":
-						set_msg_as_unflagged(rowids_to_set[i]);
-						if (_fld_box)
 						    set_msg_as_unflagged(msgs_to_set[i]);
-						_chk_box.checked = false;
+						if(results_search_messages != "") 
+ 	                        set_msg_as_unflagged(results_search_messages, true);
+						Element("check_box_message_" + msgs_to_set[i]).checked = false;
 						break;
 				}
@@ -2064,21 +2321,10 @@
 
 	var folder = get_current_folder();
-	if (msgs_to_set == 'get_selected_messages') {
+	if (msgs_to_set == 'get_selected_messages')
 		var msgs_to_set = this.get_selected_messages();
-		if ( (msgs_to_set) && (msgs_to_set.match(/_s/)) ) {
-			folder = get_selected_messages_folder();
-			if (!folder) {
-				alert(get_lang("You cant manipulate messages from multiple folders on search"));
-				return;
-			}
-		}
-	}
 	else
 		folder = Element("input_folder_"+msgs_to_set+"_r").value;
 
 	if (msgs_to_set)
-		if (folder && proxy_mensagens.is_local_folder(folder))
-			expresso_local_messages.set_messages_flag(msgs_to_set, flag); //expresso_local_messages.set_messages_flag(msgs_to_set.replace(/_s[^,]*/g,""), flag);
-		else
 		cExecute ("$this.imap_functions.set_messages_flag&folder="+folder+"&msgs_to_set="+msgs_to_set+"&flag="+flag, handler_set_messages_flag);
 	else
@@ -2137,5 +2383,15 @@
 	var folder= Element('border_id_0').innerHTML;
 	var thead = Element('divScrollHead_'+numBox).firstChild.firstChild.innerHTML;
+	
+	msgs_number = get_selected_messages();
+	if(msgs_number == false){
 	var tbody = Element('divScrollMain_'+numBox).firstChild.firstChild.innerHTML;
+	}else{
+		msgs_number = msgs_number.split(",");
+		var tbody = "";
+		for(var i = 0; i < msgs_number.length; i++){
+			tbody += "<tr id="+msgs_number[i]+" class=\"tr_msg_unread tr_msg_read2\">"+ Element(msgs_number[i]).innerHTML+"</tr>";
+		}	
+	}
 	var print_width = screen.width - 200;
 	var x = ((screen.width - print_width) / 2);
@@ -2151,5 +2407,6 @@
 	thead = thead.replace(seekDot, "style='display:none'");
 	tbody = tbody.replace(seekDot, "style='display:none'");
-
+	thead = thead.replace("<td style=\"cursor: pointer;\"></td>", "");		
+	thead = thead.replace("<td style=\"cursor: pointer;\" style='display:none'><input title=\"Selecionar todas as mensagens.\" class=\"checkbox\" id=\"chk_box_select_all_messages\" type=\"checkbox\"></td>", "");
 	while (1){
 		try{
@@ -2157,5 +2414,5 @@
 			var html = '<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd"><html>'
 			+ '<head><link rel="stylesheet" type="text/css" href="templates/'+template+'/print.css"></head>'
-			+ '<body class="print-all-messages"><h1>ExpressoLivre - ExpressoMail</h1>'
+	 	    + cabecalho + '</h4><hr>' 
 			+ '<h2>'+folder+'</h2><hr/><blockquote><font size="2">'
 			+ '<table width="100%" cellpadding="0" cellspacing="0">'
@@ -2204,24 +2461,9 @@
 		else if(countAtt > 1) 
 			for (var i = 1; i <attachments.getElementsByTagName('a').length; i++) 
-				att += attachments.getElementsByTagName('a')[i].innerHTML + " | "; 
+				att += " | " + attachments.getElementsByTagName('a')[i].innerHTML; 
  	} 
  	        
 	var body = Element('body_'+border_ID); 
 	
-        if(!is_ie)
-            {
-                var link = location.href.replace(/\/expressoMail1_2\/(.*)/, "");
-                var tab_tags = body.getElementsByTagName("IMG");
-                for(var i = 0; i < tab_tags.length;i++)
-                    {
-                        var _img = document.createElement("IMG");
-                        _img.src = tab_tags[i].src;
-                        if(tab_tags[i].src.toUpperCase().indexOf('/INC/SHOW_EMBEDDED_ATTACH.PHP?MSG_FOLDER=') > -1)
-                            {
-                                _img.src = link + '/expressoMail1_2'+tab_tags[i].src.substr(tab_tags[i].src.toUpperCase().indexOf('/INC/SHOW_EMBEDDED_ATTACH.PHP?MSG_FOLDER='));
-                            }
-                        tab_tags[i].parentNode.replaceChild(_img,tab_tags[i]);
-                    }
-            }
 	var print_width = screen.width - 200;
 	var x = ((screen.width - print_width) / 2);
@@ -2258,5 +2500,5 @@
 		try{
 			var html ='<body>';
-			html += "<h4>ExpressoLivre - ExpressoMail</h4><hr>";
+			html += cabecalho + '</h4><hr>';
 			html += '<table><tbody>';
 			if(sender)
@@ -2289,12 +2531,15 @@
 			html += "</tbody></table><hr>";
 			window_print.document.write(html + body.innerHTML);
-			if(!is_ie){
+
 				var tab_tags = window_print.document.getElementsByTagName("IMG");
+                        var link = location.href.replace(/\/expressoMail1_2\/(.*)/, "");
 				for(var i = 0; i < tab_tags.length;i++){
-					var _img = document.createElement("IMG");
-					_img.src = tab_tags[i].src;
+                                var _img = tab_tags[i].cloneNode(true);
+                                if(tab_tags[i].src.toUpperCase().indexOf('INC/GET_ARCHIVE.PHP?MSGFOLDER=') > -1)
+                                    _img.src = link + '/expressoMail1_2/'+tab_tags[i].src.substr(tab_tags[i].src.toUpperCase().indexOf('INC/GET_ARCHIVE.PHP?MSGFOLDER='));
+
 					tab_tags[i].parentNode.replaceChild(_img,tab_tags[i]);
 				}
-			}
+                        
 			break;
 		}
@@ -2319,5 +2564,5 @@
 			if (get_current_folder() == 'INBOX'+cyrus_delimiter+trashfolder){
 				draw_paging(0);
-				kill_current_box();
+				remove_rows(document.getElementById("table_box"));				
 				Element('tot_m').innerHTML = 0;
 				Element('new_m').innerHTML = 0;
@@ -2339,5 +2584,5 @@
 		if (get_current_folder() == 'INBOX'+cyrus_delimiter+spamfolder){
 			draw_paging(0);
-			kill_current_box();
+			remove_rows(document.getElementById("table_box"));
 		}
 		tree_folders.getNodeById('INBOX'+cyrus_delimiter+spamfolder).alter({caption: get_lang("Spam")});
@@ -2367,6 +2612,11 @@
 			write_msg(get_lang('Error compressing messages (ZIP). Contact the administrator.'));
 		}
-		else
-			download_attachments(null, null, data, null,null,'mensagens.zip');
+		else{
+			var filename = 'mensagens.zip'; 
+			if (data.match(/\.eml$/gi)) { 
+	                        filename = 'fonte_da_mensagem.eml'; 
+			} 
+			download_attachments(null, null, data, null,null,filename);
+		}
 	}
 
@@ -2379,19 +2629,23 @@
 }
 
-function select_all_search_messages(select, id){
-	var search_box = Element("table_resultsearch_" + getNumBoxFromTabId(id)).firstChild;
-	var felement = search_box.firstChild;
-	while(felement)
-	{
-		if (select) {
-			felement.firstChild.firstChild.checked = true;
-			add_className(felement, 'selected_msg');
-		}
-		else {
-			felement.firstChild.firstChild.checked = false;
-			remove_className(felement, 'selected_msg');
-		}
-		felement = felement.nextSibling;
-	}
+function select_all_search_messages(select, aba){
+	   jQuery(function() {
+        if(select){
+			jQuery("#"+aba+" tr").each(function(i, o) {
+			
+				o.firstChild.firstChild.checked = true;
+				add_className(o, 'selected_msg');
+			});		
+		}else{
+			jQuery("#"+aba+" tr").each(function(i, o) {
+			
+				o.firstChild.firstChild.checked = false;
+				remove_className(o, 'selected_msg');
+			});
+	}
+	});
+
+	
+
 }
 
@@ -2426,9 +2680,20 @@
 	}
 }
+function save_image2(info){ 
+	var obj = jQuery.parseJSON(unescape(info)); 
+	download_attachments(obj.folder, obj.message, obj.thumbIndex, obj.pid, obj.encoding, obj.type.replace("/",".")); 
+} 
 
 function nospam(msgs_number, border_ID, folder){
 	if (folder == 'null')
 		folder = get_current_folder();
-	var new_folder 	= 'INBOX';
+	var new_folder = '';
+	if(folder.substr(0,4) == 'user'){
+		arrayFolder = folder.split(cyrus_delimiter);
+		new_folder = 'user'+cyrus_delimiter+arrayFolder[1];
+	}
+	else{
+		new_folder = 'INBOX';
+	}
 	var new_folder_name = get_lang('INBOX');
 	var handler_move_msgs = function(data){
@@ -2449,5 +2714,5 @@
 
 	if (parseInt(msgs_number) > 0 || msgs_number.length > 0)
-		cExecute ("$this.imap_functions.spam&folder="+folder+"&spam=false"+"&msgs_number="+msgs_number+"&border_ID="+border_ID+"&sort_box_type="+sort_box_type+"&sort_box_reverse="+sort_box_reverse+"&reuse_border="+border_ID+"&new_folder="+new_folder+"&new_folder_name="+new_folder_name+"&get_previous_msg="+preferences.delete_and_show_previous_message+"&cyrus_delimiter="+cyrus_delimiter, handler_move_msgs);
+		cExecute ("$this.imap_functions.spam&folder="+folder+"&spam=false"+"&msgs_number="+msgs_number+"&border_ID="+border_ID+"&sort_box_type="+sort_box_type+"&sort_box_reverse="+sort_box_reverse+"&reuse_border="+border_ID+"&new_folder="+new_folder+"&new_folder_name="+new_folder_name+"&get_previous_msg="+0+"&cyrus_delimiter="+cyrus_delimiter, handler_move_msgs);
 	else
 		write_msg(get_lang('No selected message.'));
@@ -2457,10 +2722,22 @@
 	if (folder == 'null')
 		folder = get_current_folder();
-	var new_folder = 'INBOX'+cyrus_delimiter+'Spam';
+	var new_folder = '';
+	if(folder.substr(0,4) == 'user')
+	{       
+		arrayFolder = folder.split(cyrus_delimiter);
+		new_folder = 'user'+cyrus_delimiter+arrayFolder[1]+cyrus_delimiter+spamfolder;
+	}
+	else
+	{
+		new_folder = 'INBOX' + cyrus_delimiter + spamfolder;
+	}
 	var new_folder_name = 'Spam';
+	var not_opem_previus = true;
 	var handler_move_msgs = function(data){
-		proxy_mensagens.proxy_move_messages(folder, msgs_number, border_ID, new_folder, new_folder_name);
-		if (openTab.type[currentTab] > 1)
+		proxy_mensagens.proxy_move_messages(folder, msgs_number, border_ID, new_folder, new_folder_name, not_opem_previus);
+		if (openTab.type[currentTab] > 1){
+			if(preferences.delete_and_show_previous_message == 1)
 			delete_border(currentTab,'false');
+	}
 	}
 
@@ -2471,5 +2748,5 @@
 
 	if(parseInt(msgs_number) > 0 || msgs_number.length > 0)
-		cExecute ("$this.imap_functions.spam&folder="+folder+"&spam=true"+"&msgs_number="+msgs_number+"&border_ID="+border_ID+"&sort_box_type="+sort_box_type+"&sort_box_reverse="+sort_box_reverse+"&reuse_border="+border_ID+"&new_folder="+new_folder+"&new_folder_name="+new_folder_name+"&get_previous_msg="+preferences.delete_and_show_previous_message+"&cyrus_delimiter="+cyrus_delimiter, handler_move_msgs);
+		cExecute ("$this.imap_functions.spam&folder="+folder+"&spam=true"+"&msgs_number="+msgs_number+"&border_ID="+border_ID+"&sort_box_type="+sort_box_type+"&sort_box_reverse="+sort_box_reverse+"&reuse_border="+border_ID+"&new_folder="+new_folder+"&new_folder_name="+new_folder_name+"&get_previous_msg="+0+"&cyrus_delimiter="+cyrus_delimiter, handler_move_msgs);
 	else
 		write_msg(get_lang('No selected message.'));
@@ -2565,6 +2842,7 @@
 			if ( er.test(wfolders_tree._selected.id) )
 			{
-				archive_msgs('INBOX/Lixeira/tmpMoveToLocal',wfolders_tree._selected.id,data);
-				cExecute('$this.imap_functions.delete_mailbox',function(){},'del_past=INBOX/Lixeira/tmpMoveToLocal');
+				alert( "Mensagens não podem ser importadas em pastas locais" );
+				//archive_msgs('INBOX/Lixeira/tmpMoveToLocal',wfolders_tree._selected.id,data);
+				//cExecute('$this.imap_functions.delete_mailbox',function(){},'del_past=INBOX/Lixeira/tmpMoveToLocal');
 			}
 						 else{
@@ -2614,12 +2892,40 @@
 }
 function import_calendar(data){
+    var import_url = '$this.db_functions.import_vcard&msg_folder='+data;
+
 	function handler_import_calendar(data){
 		if(data === true){
 			write_msg(get_lang("The event was imported successfully."));
 		}
+            else if( data['url'] )
+            {
+                var form = document.createElement( "form" );
+
+                form.setAttribute( "action", DEFAULT_URL + data['url'] + '&isPost=true' );
+                form.setAttribute( "method", "POST" );
+
+                document.body.appendChild( form );
+
+                form.submit();
+            }
+            else
+                write_msg(get_lang(data));
 	}
 	if(confirm(get_lang("Do you confirm this import to your Calendar?"))){
-			cExecute('$this.db_functions.import_vcard&msg_folder='+data,handler_import_calendar);
-	}
+                    cExecute( import_url +'&from_ajax=true',handler_import_calendar);
+    }
+}
+function open_msg_part(data){
+	var handler_open_msg_part = function (data)
+        {
+            if(data.append == 1)
+            {
+                proxy_mensagens.get_msg(data.msg_number,data.msg_folder,false,show_msg);
+                partMsgs.push(data.msg_number);
+	}
+            else
+               write_msg(data.append);
+	}
+        cExecute('$this.imap_functions.ope_msg_part&msg_folder='+data+'&save_folder=INBOX'+cyrus_delimiter+trashfolder , handler_open_msg_part);	
 }
 function hack_sent_queue(data,rowid_message) {
@@ -2696,5 +3002,5 @@
 		var er_Email =  new RegExp("<(.*?)>"); 
                 // TODO Use validateEmail of common functions !
-		var er_ValidaEmail = new RegExp("^[_a-z0-9-]+(\.[_a-z0-9-]+)*@[a-z0-9-]+(\.[a-z0-9-]+)*(\.[a-z]{2,3})$");
+		var er_ValidaEmail = new RegExp("^[_a-zA-Z0-9-]+(\.[_a-zA-Z0-9-]+)*@[a-zA-Z0-9-]+(\.[a-zA-Z0-9-]+)*(\.[a-zA-Z]{2,3})$");
 
 		for (i=0; i < arrayEmailsFull.length; i++){
@@ -2702,10 +3008,10 @@
 			tempEmail = email == null  ? arrayEmailsFull[i]:email[1];
 			tempEmail = tempEmail.replace(/^\s+|\s+$/g,"");
+			
 			if (tempEmail != '') {
 				singleEmail = er_ValidaEmail.exec(tempEmail);
-
 				if (singleEmail == null) {
 					arrayInvalidEmails[0] = true;
-					arrayInvalidEmails[1] += (email == null ? arrayEmailsFull[i] : email[1]) + "; ";
+					arrayInvalidEmails[1] += (email == null ? arrayEmailsFull[i] : email[1]) + "";
 				}
 			}
Index: trunk/expressoMail1_2/js/connector.js
===================================================================
--- trunk/expressoMail1_2/js/connector.js	(revision 4760)
+++ trunk/expressoMail1_2/js/connector.js	(revision 5134)
@@ -428,13 +428,15 @@
 	}
 	// Cancel Request Connector
-	cConnector.prototype.cancelRequest = function (){
-
-                if (!this.requests[this.tid]){
+	cConnector.prototype.cancelRequest = function (id){
+
+		id = id || this.tid;
+
+                if (!this.requests[id]){
 			return false;
 		}
 		//this.oxmlhttp.onreadystatechange = null;
-                this.requests[this.tid].abort();
-                delete this.requests[this.tid];
-		this.requests[this.tid] = null;
+                this.requests[id].abort();
+                delete this.requests[id];
+		this.requests[id] = null;
 		
 		this.hideProgressBar();
